/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#ifndef BRICKLET_ANALOG_OUT_H
#define BRICKLET_ANALOG_OUT_H

#include "ip_connection.h"

/**
 * \defgroup BrickletAnalogOut AnalogOut Bricklet
 */

/**
 * \ingroup BrickletAnalogOut
 *
 * Device for output of voltage between 0 and 5V
 */
typedef Device AnalogOut;

/**
 * \ingroup BrickletAnalogOut
 */
#define ANALOG_OUT_FUNCTION_SET_VOLTAGE 1

/**
 * \ingroup BrickletAnalogOut
 */
#define ANALOG_OUT_FUNCTION_GET_VOLTAGE 2

/**
 * \ingroup BrickletAnalogOut
 */
#define ANALOG_OUT_FUNCTION_SET_MODE 3

/**
 * \ingroup BrickletAnalogOut
 */
#define ANALOG_OUT_FUNCTION_GET_MODE 4

/**
 * \ingroup BrickletAnalogOut
 */
#define ANALOG_OUT_FUNCTION_GET_IDENTITY 255

/**
 * \ingroup BrickletAnalogOut
 *
 * The device identifier is used to identify a device in the enumerate callback
 * of the IPConnection.
 */
#define ANALOG_OUT_DEVICE_IDENTIFIER 220

/**
 * \ingroup BrickletAnalogOut
 *
 * Creates the device object \u analog_out with the unique device ID \c uid and adds
 * it to the IPConnection \c ipcon.
 */
void analog_out_create(AnalogOut *analog_out, const char *uid, IPConnection *ipcon);

/**
 * \ingroup BrickletAnalogOut
 *
 * Removes the device object \u analog_out from its IPConnection and destroys it.
 * The device object cannot be used anymore afterwards.
 */
void analog_out_destroy(AnalogOut *analog_out);

int analog_out_get_response_expected(AnalogOut *analog_out, uint8_t function_id);

void analog_out_set_response_expected(AnalogOut *analog_out, uint8_t function_id, bool response_expected);

void analog_out_set_response_expected_all(AnalogOut *analog_out, bool response_expected);


/**
 * \ingroup BrickletAnalogOut
 *
 * Returns the name (including the hardware version), the firmware version
 * and the binding version of the device. The firmware and binding versions are
 * given in arrays of size 3 with the syntax [major, minor, revision].
 */
int analog_out_get_api_version(AnalogOut *analog_out, uint8_t ret_api_version[3]);

/**
 * \ingroup BrickletAnalogOut
 *
 * Sets the voltage in mV. The possible range is 0V to 5V (0-5000).
 * Calling this function will set the mode to 0 (see {@link analog_out_set_mode}).
 * 
 * The default value is 0 (with mode 1).
 */
int analog_out_set_voltage(AnalogOut *analog_out, uint16_t voltage);

/**
 * \ingroup BrickletAnalogOut
 *
 * Returns the voltage as set by {@link analog_out_set_voltage}.
 */
int analog_out_get_voltage(AnalogOut *analog_out, uint16_t *ret_voltage);

/**
 * \ingroup BrickletAnalogOut
 *
 * Sets the mode of the analog value. Possible modes:
 * 
 * * 0: Normal Mode (Analog value as set by {@link analog_out_set_voltage} is applied
 * * 1: 1k Ohm resistor to ground
 * * 2: 100k Ohm resistor to ground
 * * 3: 500k Ohm resistor to ground
 * 
 * Setting the mode to 0 will result in an output voltage of 0. You can jump
 * to a higher output voltage directly by calling {@link analog_out_set_voltage}.
 * 
 * The default mode is 1.
 */
int analog_out_set_mode(AnalogOut *analog_out, uint8_t mode);

/**
 * \ingroup BrickletAnalogOut
 *
 * Returns the mode as set by {@link analog_out_set_mode}.
 */
int analog_out_get_mode(AnalogOut *analog_out, uint8_t *ret_mode);

/**
 * \ingroup BrickletAnalogOut
 *
 * Returns the UID, the UID where the Bricklet is connected to, 
 * the position, the hardware and firmware version as well as the
 * device identifier.
 * 
 * The position can be 'a', 'b', 'c' or 'd'.
 * 
 * The device identifiers are:
 * 
 * \verbatim
 *  "Device Identifier", "Device"
 * 
 *  "11", "Brick DC"
 *  "12", "Brick Debug"
 *  "13", "Brick Master 2.0"
 *  "14", "Brick Servo"
 *  "15", "Brick Stepper"
 *  "16", "Brick IMU"
 *  "", ""
 *  "21", "Bricklet Ambient Light"
 *  "22", "Bricklet Breakout"
 *  "23", "Bricklet Current12"
 *  "24", "Bricklet Current25"
 *  "25", "Bricklet Distance IR"
 *  "26", "Bricklet Dual Relay"
 *  "27", "Bricklet Humidity"
 *  "28", "Bricklet IO-16"
 *  "29", "Bricklet IO-4"
 *  "210", "Bricklet Joystick"
 *  "211", "Bricklet LCD 16x2"
 *  "212", "Bricklet LCD 20x4"
 *  "213", "Bricklet Linear Poti"
 *  "214", "Bricklet Piezo Buzzer"
 *  "215", "Bricklet Rotary Poti"
 *  "216", "Bricklet Temperature"
 *  "217", "Bricklet Temperature IR"
 *  "218", "Bricklet Voltage"
 *  "219", "Bricklet Analog In"
 *  "220", "Bricklet Analog Out"
 *  "221", "Bricklet Barometer"
 *  "222", "Bricklet GPS"
 *  "223", "Bricklet Industrial Digital In 4"
 *  "224", "Bricklet Industrial Digital Out 4"
 *  "225", "Bricklet Industrial Quad Relay"
 *  "226", "Bricklet PTC"
 *  "227", "Bricklet Voltage/Current"
 * \endverbatim
 * 
 * .. versionadded:: 2.0.0~(Plugin)
 */
int analog_out_get_identity(AnalogOut *analog_out, char ret_uid[8], char ret_connected_uid[8], char *ret_position, uint8_t ret_hardware_version[3], uint8_t ret_firmware_version[3], uint16_t *ret_device_identifier);

#endif
