/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#ifndef BRICKLET_PIEZO_BUZZER_H
#define BRICKLET_PIEZO_BUZZER_H

#include "ip_connection.h"

/**
 * \defgroup BrickletPiezoBuzzer PiezoBuzzer Bricklet
 */

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * Device for controlling a piezo buzzer
 */
typedef Device PiezoBuzzer;

/**
 * \ingroup BrickletPiezoBuzzer
 */
#define PIEZO_BUZZER_FUNCTION_BEEP 1

/**
 * \ingroup BrickletPiezoBuzzer
 */
#define PIEZO_BUZZER_FUNCTION_MORSE_CODE 2

/**
 * \ingroup BrickletPiezoBuzzer
 */
#define PIEZO_BUZZER_FUNCTION_GET_IDENTITY 255

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * This callback is triggered if a beep set by {@link piezo_buzzer_beep} is finished
 */
#define PIEZO_BUZZER_CALLBACK_BEEP_FINISHED 3

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * This callback is triggered if the playback of the morse code set by
 * {@link piezo_buzzer_morse_code} is finished.
 */
#define PIEZO_BUZZER_CALLBACK_MORSE_CODE_FINISHED 4

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * The device identifier is used to identify a device in the enumerate callback
 * of the IPConnection.
 */
#define PIEZO_BUZZER_DEVICE_IDENTIFIER 214

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * Creates the device object \u piezo_buzzer with the unique device ID \c uid and adds
 * it to the IPConnection \c ipcon.
 */
void piezo_buzzer_create(PiezoBuzzer *piezo_buzzer, const char *uid, IPConnection *ipcon);

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * Removes the device object \u piezo_buzzer from its IPConnection and destroys it.
 * The device object cannot be used anymore afterwards.
 */
void piezo_buzzer_destroy(PiezoBuzzer *piezo_buzzer);

int piezo_buzzer_get_response_expected(PiezoBuzzer *piezo_buzzer, uint8_t function_id);

void piezo_buzzer_set_response_expected(PiezoBuzzer *piezo_buzzer, uint8_t function_id, bool response_expected);

void piezo_buzzer_set_response_expected_all(PiezoBuzzer *piezo_buzzer, bool response_expected);

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * Registers a callback with ID \c id to the function \c callback.
 */
void piezo_buzzer_register_callback(PiezoBuzzer *piezo_buzzer, uint8_t id, void *callback, void *user_data);

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * Returns the name (including the hardware version), the firmware version
 * and the binding version of the device. The firmware and binding versions are
 * given in arrays of size 3 with the syntax [major, minor, revision].
 */
int piezo_buzzer_get_api_version(PiezoBuzzer *piezo_buzzer, uint8_t ret_api_version[3]);

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * Beeps with the duration in ms. For example: If you set a value of 1000,
 * the piezo buzzer will beep for one second.
 */
int piezo_buzzer_beep(PiezoBuzzer *piezo_buzzer, uint32_t duration);

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * Sets morse code that will be played by the piezo buzzer. The morse code
 * is given as a string consisting of "." (dot), "-" (minus) and " " (space)
 * for *dits*, *dahs* and *pauses*. Every other character is ignored.
 * 
 * For example: If you set the string "...---...", the piezo buzzer will beep
 * nine times with the durations "short short short long long long short 
 * short short".
 * 
 * The maximum string size is 60.
 */
int piezo_buzzer_morse_code(PiezoBuzzer *piezo_buzzer, char morse[60]);

/**
 * \ingroup BrickletPiezoBuzzer
 *
 * Returns the UID, the UID where the Bricklet is connected to, 
 * the position, the hardware and firmware version as well as the
 * device identifier.
 * 
 * The position can be 'a', 'b', 'c' or 'd'.
 * 
 * The device identifiers are:
 * 
 * \verbatim
 *  "Device Identifier", "Device"
 * 
 *  "11", "Brick DC"
 *  "12", "Brick Debug"
 *  "13", "Brick Master 2.0"
 *  "14", "Brick Servo"
 *  "15", "Brick Stepper"
 *  "16", "Brick IMU"
 *  "", ""
 *  "21", "Bricklet Ambient Light"
 *  "22", "Bricklet Breakout"
 *  "23", "Bricklet Current12"
 *  "24", "Bricklet Current25"
 *  "25", "Bricklet Distance IR"
 *  "26", "Bricklet Dual Relay"
 *  "27", "Bricklet Humidity"
 *  "28", "Bricklet IO-16"
 *  "29", "Bricklet IO-4"
 *  "210", "Bricklet Joystick"
 *  "211", "Bricklet LCD 16x2"
 *  "212", "Bricklet LCD 20x4"
 *  "213", "Bricklet Linear Poti"
 *  "214", "Bricklet Piezo Buzzer"
 *  "215", "Bricklet Rotary Poti"
 *  "216", "Bricklet Temperature"
 *  "217", "Bricklet Temperature IR"
 *  "218", "Bricklet Voltage"
 *  "219", "Bricklet Analog In"
 *  "220", "Bricklet Analog Out"
 *  "221", "Bricklet Barometer"
 *  "222", "Bricklet GPS"
 *  "223", "Bricklet Industrial Digital In 4"
 *  "224", "Bricklet Industrial Digital Out 4"
 *  "225", "Bricklet Industrial Quad Relay"
 *  "226", "Bricklet PTC"
 *  "227", "Bricklet Voltage/Current"
 * \endverbatim
 * 
 * .. versionadded:: 2.0.0~(Plugin)
 */
int piezo_buzzer_get_identity(PiezoBuzzer *piezo_buzzer, char ret_uid[8], char ret_connected_uid[8], char *ret_position, uint8_t ret_hardware_version[3], uint8_t ret_firmware_version[3], uint16_t *ret_device_identifier);

#endif
