/* ***********************************************************
 * This file was automatically generated on 2012-12-21.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#ifndef BRICKLET_TEMPERATURE_H
#define BRICKLET_TEMPERATURE_H

#include "ip_connection.h"

/**
 * \defgroup BrickletTemperature Temperature Bricklet
 */

/**
 * \ingroup BrickletTemperature
 *
 * Device for sensing Temperature
 */
typedef Device Temperature;

/**
 * \ingroup BrickletTemperature
 */
#define TEMPERATURE_FUNCTION_GET_TEMPERATURE 1

/**
 * \ingroup BrickletTemperature
 */
#define TEMPERATURE_FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD 2

/**
 * \ingroup BrickletTemperature
 */
#define TEMPERATURE_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD 3

/**
 * \ingroup BrickletTemperature
 */
#define TEMPERATURE_FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD 4

/**
 * \ingroup BrickletTemperature
 */
#define TEMPERATURE_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD 5

/**
 * \ingroup BrickletTemperature
 */
#define TEMPERATURE_FUNCTION_SET_DEBOUNCE_PERIOD 6

/**
 * \ingroup BrickletTemperature
 */
#define TEMPERATURE_FUNCTION_GET_DEBOUNCE_PERIOD 7

/**
 * \ingroup BrickletTemperature
 */
#define TEMPERATURE_FUNCTION_GET_IDENTITY 255

/**
 * \ingroup BrickletTemperature
 *
 * This callback is triggered periodically with the period that is set by
 * {@link temperature_set_temperature_callback_period}. The parameter is the temperature
 * of the sensor.
 * 
 * {@link TEMPERATURE_CALLBACK_TEMPERATURE} is only triggered if the temperature has changed since the
 * last triggering.
 */
#define TEMPERATURE_CALLBACK_TEMPERATURE 8

/**
 * \ingroup BrickletTemperature
 *
 * This callback is triggered when the threshold as set by
 * {@link temperature_set_temperature_callback_threshold} is reached.
 * The parameter is the temperature of the sensor.
 * 
 * If the threshold keeps being reached, the callback is triggered periodically
 * with the period as set by {@link temperature_set_debounce_period}.
 */
#define TEMPERATURE_CALLBACK_TEMPERATURE_REACHED 9

/**
 * \ingroup BrickletTemperature
 *
 * The device identifier is used to identify a device in the enumerate callback
 * of the IPConnection.
 */
#define TEMPERATURE_DEVICE_IDENTIFIER 216

/**
 * \ingroup BrickletTemperature
 *
 * Creates the device object \u temperature with the unique device ID \c uid and adds
 * it to the IPConnection \c ipcon.
 */
void temperature_create(Temperature *temperature, const char *uid, IPConnection *ipcon);

/**
 * \ingroup BrickletTemperature
 *
 * Removes the device object \u temperature from its IPConnection and destroys it.
 * The device object cannot be used anymore afterwards.
 */
void temperature_destroy(Temperature *temperature);

int temperature_get_response_expected(Temperature *temperature, uint8_t function_id);

void temperature_set_response_expected(Temperature *temperature, uint8_t function_id, bool response_expected);

void temperature_set_response_expected_all(Temperature *temperature, bool response_expected);

/**
 * \ingroup BrickletTemperature
 *
 * Registers a callback with ID \c id to the function \c callback.
 */
void temperature_register_callback(Temperature *temperature, uint8_t id, void *callback, void *user_data);

/**
 * \ingroup BrickletTemperature
 *
 * Returns the name (including the hardware version), the firmware version
 * and the binding version of the device. The firmware and binding versions are
 * given in arrays of size 3 with the syntax [major, minor, revision].
 */
int temperature_get_api_version(Temperature *temperature, uint8_t ret_api_version[3]);

/**
 * \ingroup BrickletTemperature
 *
 * Returns the temperature of the sensor. The value
 * has a range of -2500 to 8500 and is given in °C/100,
 * e.g. a value of 4223 means that a temperature of 42.23 °C is measured.
 * 
 * If you want to get the temperature periodically, it is recommended 
 * to use the callback {@link TEMPERATURE_CALLBACK_TEMPERATURE} and set the period with 
 * {@link temperature_set_temperature_callback_period}.
 */
int temperature_get_temperature(Temperature *temperature, int16_t *ret_temperature);

/**
 * \ingroup BrickletTemperature
 *
 * Sets the period in ms with which the {@link TEMPERATURE_CALLBACK_TEMPERATURE} callback is triggered
 * periodically. A value of 0 turns the callback off.
 * 
 * {@link TEMPERATURE_CALLBACK_TEMPERATURE} is only triggered if the temperature has changed since the
 * last triggering.
 * 
 * The default value is 0.
 */
int temperature_set_temperature_callback_period(Temperature *temperature, uint32_t period);

/**
 * \ingroup BrickletTemperature
 *
 * Returns the period as set by {@link temperature_set_temperature_callback_period}.
 */
int temperature_get_temperature_callback_period(Temperature *temperature, uint32_t *ret_period);

/**
 * \ingroup BrickletTemperature
 *
 * Sets the thresholds for the {@link TEMPERATURE_CALLBACK_TEMPERATURE_REACHED} callback. 
 * 
 * The following options are possible:
 * 
 * \verbatim
 *  "Option", "Description"
 * 
 *  "'x'",    "Callback is turned off"
 *  "'o'",    "Callback is triggered when the temperature is *outside* the min and max values"
 *  "'i'",    "Callback is triggered when the temperature is *inside* the min and max values"
 *  "'<'",    "Callback is triggered when the temperature is smaller than the min value (max is ignored)"
 *  "'>'",    "Callback is triggered when the temperature is greater than the min value (max is ignored)"
 * \endverbatim
 * 
 * The default value is ('x', 0, 0).
 */
int temperature_set_temperature_callback_threshold(Temperature *temperature, char option, int16_t min, int16_t max);

/**
 * \ingroup BrickletTemperature
 *
 * Returns the threshold as set by {@link temperature_set_temperature_callback_threshold}.
 */
int temperature_get_temperature_callback_threshold(Temperature *temperature, char *ret_option, int16_t *ret_min, int16_t *ret_max);

/**
 * \ingroup BrickletTemperature
 *
 * Sets the period in ms with which the threshold callback
 * 
 *  {@link TEMPERATURE_CALLBACK_TEMPERATURE_REACHED}
 * 
 * is triggered, if the threshold
 * 
 *  {@link temperature_set_temperature_callback_threshold}
 * 
 * keeps being reached.
 * 
 * The default value is 100.
 */
int temperature_set_debounce_period(Temperature *temperature, uint32_t debounce);

/**
 * \ingroup BrickletTemperature
 *
 * Returns the debounce period as set by {@link temperature_set_debounce_period}.
 */
int temperature_get_debounce_period(Temperature *temperature, uint32_t *ret_debounce);

/**
 * \ingroup BrickletTemperature
 *
 * Returns the UID, the UID where the Bricklet is connected to, 
 * the position, the hardware and firmware version as well as the
 * device identifier.
 * 
 * The position can be 'a', 'b', 'c' or 'd'.
 * 
 * The device identifiers are:
 * 
 * \verbatim
 *  "Device Identifier", "Device"
 * 
 *  "11", "Brick DC"
 *  "12", "Brick Debug"
 *  "13", "Brick Master 2.0"
 *  "14", "Brick Servo"
 *  "15", "Brick Stepper"
 *  "16", "Brick IMU"
 *  "", ""
 *  "21", "Bricklet Ambient Light"
 *  "22", "Bricklet Breakout"
 *  "23", "Bricklet Current12"
 *  "24", "Bricklet Current25"
 *  "25", "Bricklet Distance IR"
 *  "26", "Bricklet Dual Relay"
 *  "27", "Bricklet Humidity"
 *  "28", "Bricklet IO-16"
 *  "29", "Bricklet IO-4"
 *  "210", "Bricklet Joystick"
 *  "211", "Bricklet LCD 16x2"
 *  "212", "Bricklet LCD 20x4"
 *  "213", "Bricklet Linear Poti"
 *  "214", "Bricklet Piezo Buzzer"
 *  "215", "Bricklet Rotary Poti"
 *  "216", "Bricklet Temperature"
 *  "217", "Bricklet Temperature IR"
 *  "218", "Bricklet Voltage"
 *  "219", "Bricklet Analog In"
 *  "220", "Bricklet Analog Out"
 *  "221", "Bricklet Barometer"
 *  "222", "Bricklet GPS"
 *  "223", "Bricklet Industrial Digital In 4"
 *  "224", "Bricklet Industrial Digital Out 4"
 *  "225", "Bricklet Industrial Quad Relay"
 *  "226", "Bricklet PTC"
 *  "227", "Bricklet Voltage/Current"
 * \endverbatim
 * 
 * .. versionadded:: 2.0.0~(Plugin)
 */
int temperature_get_identity(Temperature *temperature, char ret_uid[8], char ret_connected_uid[8], char *ret_position, uint8_t ret_hardware_version[3], uint8_t ret_firmware_version[3], uint16_t *ret_device_identifier);

#endif
